double cost1(X, BACK, STAT, line)
int **X, **BACK, line;
double *STAT;
{
	int i, j;
	double sum1, sum2, sum3, s, ns;

	sum1 = sum2 = sum3 = 0.0;
	for(i = 1; i <= 2; i++)
		for(j = 1; j <= TOOTH; j++)
			if(BACK[i][j] == 1) {
				s = X[i][j] * BACK[i][j];
				ns = X[i-1][j] * BACK[i-1][j] + X[i+1][j] * BACK[i+1][j] + X[i][j-1] * BACK[i][j-1] + X[i][j+1] * BACK[i][j+1];
				sum1 += s;
				sum2 += s * ns;
				if(s == 1) sum3 += s;
			}

	STAT[1] = 1.0 * sum3;
	STAT[2] = 0.5 * sum2;
	
	for(i = 1; i <= nCOEF1; i++) STAT[(nPARA1+i)] = COEF_A[line][i] * sum3;
	STAT[(nPARA1+nCOEF1+1)] = 1.0 * sum3;
	
	return 1.0;
}

