double cost2(DATA, BACK, STAT, AUXB, AUX, line)
int **DATA, **BACK, *AUXB, *AUX, line;
double *STAT;
{
	int i, k;
	double sumijs1, sumijs2, sumijs3;

	for(i = 1; i <= nPARA2 + nCOEF2 + 1; i++) STAT[i] = 0.0;
	for(i = 1; i <= TOOTH; i++){
		/* calculate psi_1 */
		if(BACK[1][i] * DATA[1][i] != 0 && BACK[1][i] * DATA[1][i] == BACK[2][i] * DATA[2][i]) STAT[1] += 1.0;
		if(BACK[1][i] * DATA[1][i] != 0 && BACK[1][i] * DATA[1][i] == BACK[3][i] * DATA[3][i]) STAT[1] += 1.0;
		if(BACK[1][i] * DATA[1][i] != 0 && BACK[1][i] * DATA[1][i] == BACK[4][i] * DATA[4][i]) STAT[1] += 1.0;
		if(BACK[1][i] * DATA[1][i] != 0 && BACK[1][i] * DATA[1][i] == BACK[5][i] * DATA[5][i]) STAT[1] += 1.0;
		
		/* calculate psi_2 */
		if(BACK[2][i] * DATA[2][i] != 0 && BACK[2][i] * DATA[2][i] == BACK[4][i] * DATA[4][i]) STAT[2] += 1.0;
		if(BACK[2][i] * DATA[2][i] != 0 && BACK[2][i] * DATA[2][i] == BACK[5][i] * DATA[5][i]) STAT[2] += 1.0;
		if(BACK[3][i] * DATA[3][i] != 0 && BACK[3][i] * DATA[3][i] == BACK[4][i] * DATA[4][i]) STAT[2] += 1.0;
		if(BACK[3][i] * DATA[3][i] != 0 && BACK[3][i] * DATA[3][i] == BACK[5][i] * DATA[5][i]) STAT[2] += 1.0;
        
		if(BACK[2][i] * DATA[2][i] != 0 && BACK[2][i] * DATA[2][i] == BACK[3][i] * DATA[3][i]) STAT[3] += 1.0;
		if(BACK[4][i] * DATA[4][i] != 0 && BACK[4][i] * DATA[4][i] == BACK[5][i] * DATA[5][i]) STAT[3] += 1.0;
	}
	
	/* calculate psi_3 */
	for(i = 1; i < HALF; i++)
		if(BACK[2][i] * DATA[2][i] != 0 && BACK[2][i] * DATA[2][i] == BACK[3][(i+1)] * DATA[3][(i+1)]) STAT[4] += 1.0;
	for(i = HALF+1; i < TOOTH; i++)
		if(BACK[3][i] * DATA[3][i] != 0 && BACK[3][i] * DATA[3][i] == BACK[2][(i+1)] * DATA[2][(i+1)]) STAT[4] += 1.0;
	if(BACK[2][HALF] * DATA[2][HALF] != 0 && BACK[2][HALF] * DATA[2][HALF] == BACK[2][(HALF+1)] * DATA[2][(HALF+1)]) STAT[4] += 1.0;
	
	/* calculate psi_4 */
	for(i = 1; i < TOOTH; i++){
		if(BACK[1][i] * DATA[1][i] != 0 && BACK[1][i] * DATA[1][i] == BACK[1][(i+1)] * DATA[1][(i+1)]) STAT[5] += 1.0;
		if(BACK[4][i] * DATA[4][i] != 0 && BACK[4][i] * DATA[4][i] == BACK[4][(i+1)] * DATA[4][(i+1)]) STAT[5] += 1.0;
		if(BACK[5][i] * DATA[5][i] != 0 && BACK[5][i] * DATA[5][i] == BACK[5][(i+1)] * DATA[5][(i+1)]) STAT[5] += 1.0;
	}

	/* calculate psi_5 */
	for(i = 1; i <= TOOTH; i++)
		if(BACK[1][i] * DATA[1][i] != 0 && BACK[1][i] * DATA[1][i] == AUXB[i] * AUX[i]) STAT[6] += 1.0;

	for(sumijs1 = 0.0, sumijs2 = 0.0, sumijs3 = 0.0, i = 1; i <= TOOTH; i++)
		for(k = 1; k <= nSPAT; k++)
			if(BACK[k][i] * DATA[k][i] != 0){
				if(DATA[k][i] == 2) STAT[7] += 1.0; 
				else if(DATA[k][i] == 3) STAT[8] += 1.0; 
				
				if(DATA[k][i] == 2) sumijs1 += 1.0;
				if(DATA[k][i] == 3) sumijs2 += 1.0;
				if(DATA[k][i] == 2 || DATA[k][i] == 3) sumijs3 += 1.0;
			}
	
	for(i = nPARA2 + 1; i <= nPARA2 + nCOEF1; i++) STAT[i] = sumijs1 * COEF_P[line][(i-nPARA2)];
	for(i = nPARA2 + nCOEF1 + 1; i <= nPARA2 + nCOEF2; i++) STAT[i] = sumijs2 * COEF_P[line][(i-nPARA2-nCOEF1)];
	STAT[(nPARA2 + nCOEF2 + 1)] = sumijs3;
	
	return 1.0;
}

